// Copyright (c) 2015, <your name>. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library messenger.service;

import 'package:angular/angular.dart';
import 'package:messagebox/model/message.dart';
import 'dart:async';

@Injectable()
class MessageBoxService {
  final Completer _messageEventCompleter = new Completer();
  final List<Message> _messages = new List();
  
  List<Message> get messages => new List.from(this._messages);
  
  Stream<Message> get onNewMessage => this._messageEventCompleter.future.asStream();
  
  void post(Message message) {
    this._messages.add(message);  
    this._messageEventCompleter.complete(message);
  }
  
  void error(String text) {
    this.post(new Message.withType(text, "error"));
  }
  
  void information(String text) {
    this.post(new Message.withType(text, "info"));
  }
  
  void success(String text) {
    this.post(new Message.withType(text, "success"));
  }
}
